diff -Naur openssl-1.0.0q.orig/addon/tools/filelist.py openssl-1.0.0q/addon/tools/filelist.py
--- openssl-1.0.0q.orig/addon/tools/filelist.py	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/addon/tools/filelist.py	2017-04-25 16:23:39.695528339 +0200
@@ -0,0 +1,83 @@
+
+import 	os, re,fnmatch
+import fileinput
+
+def get_filename_list(top, dir, pattern):
+	"""Recursivly generate a listing of files in the file 
+		hierarchy starting at topdir/dir and that matches the 
+		regular expression string in pattern.
+		
+		top should be an absolute path, dir is considered a relative path, and may be empty
+		
+		The returned value is a dictionary with the absolute pathname as key, and the 
+		name relative to the top directory as the value."""
+		
+	file_list = {}
+	dirbase = os.path.join(top, dir)
+	for dirpath, dirnames,filenames in os.walk(dirbase) :
+		for f in (x for x in filenames if re.search(pattern,x, re.IGNORECASE)):
+			pathname = os.path.join(dirpath, f)
+			pathname_mod = os.path.basename(f)
+			file_list[pathname]=pathname_mod
+	return file_list
+
+def remove_filtered(filelist, filters):
+	"""return a list of the (full_filename, filename) tuples in filelist
+		that does NOT match any of the entries in the filters list"""
+	filter_match = set(x for x in filters if not x.find("*"))
+	filter_wild = [x for x in filters if  x not in filter_match]
+
+	temp1 =  [f for f in filelist.values() if f not in filter_match ]
+	
+	for filter in filter_wild:
+		temp2 = fnmatch.filter(temp1, filter);
+		for f in temp2:
+			temp1.remove(f)
+					
+	return dict([(ff, f) for ff, f in filelist.items() if  f in temp1])
+	
+def keep_filtered(filelist, filters):
+	"""return a list of the (full_filename, filename) tuples in filelist 
+		that matches at least one of the entries in the filters list"""
+
+	filter_match = set(x for x in filters if x.find("*")<0)
+	filter_wild = [x for x in filters if  x not in filter_match]
+
+	temp = set(filelist.values())
+	temp1 =  temp.intersection(filter_match)
+	
+	temp2 = list(temp.difference(temp1))
+		
+	for filter in filter_wild:
+		temp3 = fnmatch.filter(temp2, filter);
+		for f in temp3:
+			temp1.add(f)
+			temp2.remove(f)
+					
+	return dict([(ff, f) for ff, f in filelist.items() if f in temp1] )
+
+def process_named_files(top,dir, name, func, param):
+	"""Read all files matching name (a regexp) in the top/dir hieratrchy, and return the 
+		call the processfiles with func and param for the resulting list of files"""
+
+	read_files_list = get_filename_list(top,dir, name)
+	
+	processfiles(read_files_list, func, param)
+
+
+def processfiles(filenames, process_func, param):
+	"""process the files in filenames (which is a dictionary with each entry 
+		of the file's absolute path (the key) and the name relative to the project top dir.
+		Each file is read and passed to the process_func along with the realtive name and the 
+		provided param parameter.
+	
+			* filenames	:	A dictionary of Full_path:relative_path string items
+			* process_func:	A function taking the arguments (rel_filename, lines, param), where filename is the current file name,
+							lines is the file contents, and param is the application specific param attribute input to this function
+			*param 			Opaque application specific structure, only used by process_func """
+	
+	for filename in filenames:
+		current_file = filenames[filename]
+		#print "Scanning ", current_file,"\n"
+		process_func(current_file,[line for line in fileinput.input(filename)], param)
+
diff -Naur openssl-1.0.0q.orig/addon/tools/pruneopenssl.py openssl-1.0.0q/addon/tools/pruneopenssl.py
--- openssl-1.0.0q.orig/addon/tools/pruneopenssl.py	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/addon/tools/pruneopenssl.py	2017-04-25 16:23:39.696528187 +0200
@@ -0,0 +1,102 @@
+
+import filelist
+import shutil,os,re
+
+openssl_path = "openssl"
+
+remove_folders=(
+		"apps",
+		"bugs",
+		"certs",
+		"demos",
+		"MacOS",
+		"ms",
+		"Netware",
+		"os2",
+		"perl",
+		"shlib",
+		"ssl",
+		"test",
+		"times",
+		"tools",
+		"util",
+		"VMS",
+		"include",
+		"openssl",
+		os.path.join("crypto","pkcs7", "p7"),
+		os.path.join("crypto","pkcs7", "t"),
+		os.path.join("crypto","des", "times"),
+		os.path.join("crypto","des", "t"),
+		os.path.join("doc","apps"),
+		os.path.join("doc","ssl")
+		)
+		
+remove_file_patterns = (
+	"makefile\.*",
+	"install.*",
+	".*\.com",
+	"README.*",
+	"VERSION",
+	"FAQ",
+	"config.*",
+	"news",
+	"openssl.doxy",
+	"openssl.spec",
+	"problems"
+)
+
+
+extra_hfiles = [
+	"cryptlib.h",
+	"e_os.h",
+	"e_os2.h",
+	"ext_dat.h",
+	"md32_common.h",
+	"mdc2.h",
+	"o_time.h",
+	"rc5.h"
+	]
+	
+extra_to_delete_after = [
+	"e_os.h",
+	"e_os2.h"
+	]
+	
+dirlist = [x for x in sorted(os.listdir(".")) if re.match("openssl", x, re.IGNORECASE)];
+if dirlist:
+	openssl_path = dirlist[-1]
+	
+files_to_copy = filelist.get_filename_list(os.path.join(openssl_path, "include", "openssl"), "",".*")
+
+for folder in remove_folders:
+	to_delete = os.path.join(openssl_path, folder)
+	print "delete ", to_delete
+	try:
+		shutil.rmtree(to_delete);
+	except:
+		print "not present"
+
+files_to_delete = {}
+for pat in remove_file_patterns:
+	files_to_delete.update(filelist.get_filename_list(openssl_path,"",pat))
+
+for file in files_to_delete:
+	print "delete ", file
+	os.remove(file)
+
+try:
+	os.makedirs(os.path.join(openssl_path,"openssl"))
+except:
+	print "directory already created"
+
+h_files =filelist.get_filename_list(openssl_path,"",".*\.h")
+
+copy_h_files = filelist.keep_filtered(h_files, files_to_copy.values()+ extra_hfiles)
+
+for file in copy_h_files:
+	print "copy file ", file, " to openssl directory"
+	shutil.copyfile(file, os.path.join(openssl_path,"openssl", os.path.basename(file)));
+	
+for file in extra_to_delete_after:
+	print "delete ", file
+	os.remove(os.path.join(openssl_path,file));
diff -Naur openssl-1.0.0q.orig/addon/utcprint.c openssl-1.0.0q/addon/utcprint.c
--- openssl-1.0.0q.orig/addon/utcprint.c	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/addon/utcprint.c	2017-04-25 16:23:39.697529711 +0200
@@ -0,0 +1,122 @@
+/* -*- Mode: c++; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*-
+**
+** Copyright (C) 1995-2008 Opera Software AS.  All rights reserved.
+**
+** This file is part of the Opera web browser.  It may not be distributed
+** under any circumstances.
+**
+*/
+
+/* crypto/addon/utcprint.c adapted from crypto/asn1/t_x509.c */
+/* Copyright (C) 1995-1997 Eric Young (eay@mincom.oz.au)
+ * All rights reserved.
+ *
+ * This package is an SSL implementation written
+ * by Eric Young (eay@mincom.oz.au).
+ * The implementation was written so as to conform with Netscapes SSL.
+ * 
+ * This library is free for commercial and non-commercial use as long as
+ * the following conditions are aheared to.  The following conditions
+ * apply to all code found in this distribution, be it the RC4, RSA,
+ * lhash, DES, etc., code; not just the SSL code.  The SSL documentation
+ * included with this distribution is covered by the same copyright terms
+ * except that the holder is Tim Hudson (tjh@mincom.oz.au).
+ * 
+ * Copyright remains Eric Young's, and as such any Copyright notices in
+ * the code are not to be removed.
+ * If this package is used in a product, Eric Young should be given attribution
+ * as the author of the parts of the library used.
+ * This can be in the form of a textual message at program startup or
+ * in documentation (online or textual) provided with the package.
+ * 
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *    "This product includes cryptographic software written by
+ *     Eric Young (eay@mincom.oz.au)"
+ *    The word 'cryptographic' can be left out if the rouines from the library
+ *    being used are not cryptographic related :-).
+ * 4. If you include any Windows specific code (or a derivative thereof) from 
+ *    the apps directory (application code) you must include an acknowledgement:
+ *    "This product includes software written by Tim Hudson (tjh@mincom.oz.au)"
+ * 
+ * THIS SOFTWARE IS PROVIDED BY ERIC YOUNG ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ * 
+ * The licence and distribution terms for any publically available version or
+ * derivative of this code cannot be changed.  i.e. this code cannot simply be
+ * copied and put under another distribution licence
+ * [including the GNU Public Licence.]
+ */
+#include "modules/libopeay/openssl/cryptlib.h"
+#include "modules/libopeay/openssl/asn1.h"
+#include "modules/pi/OpLocale.h"
+
+int ASN1_UTCTIME_unisprint(uni_char *sp, ASN1_UTCTIME *tm_string)
+    {
+    char *v;
+    int n,i;
+    int y=0,M=0;
+
+	struct tm time_data;
+
+    n=tm_string->length;
+    v=(char *)tm_string->data;
+
+	if (n < (tm_string->type == V_ASN1_GENERALIZEDTIME ? 12 : 10)) goto err;
+	n =(tm_string->type == V_ASN1_GENERALIZEDTIME ? 12 : 10);
+    for (i=0; i<n; i++)
+        if ((v[i] > '9') || (v[i] < '0')) goto err;
+    
+	y= (v[0]-'0')*10+(v[1]-'0');
+	if(n>10)
+	{
+		v+=2;
+		y= y*100 + (v[0]-'0')*10+(v[1]-'0') -1900;
+	}
+    if (y < 70) y+=100;
+	time_data.tm_year = y;
+
+    M= (v[2]-'0')*10+(v[3]-'0');
+    if ((M > 12) || (M < 1)) goto err;
+	time_data.tm_mon = M-1;
+
+	time_data.tm_mday = (v[4]-'0')*10+(v[5]-'0');
+	time_data.tm_hour = (v[6]-'0')*10+(v[7]-'0');
+	time_data.tm_min =  (v[8]-'0')*10+(v[9]-'0');
+    if (    (v[10] >= '0') && (v[10] <= '9') &&
+        (v[11] >= '0') && (v[11] <= '9'))
+		time_data.tm_sec =  (v[10]-'0')*10+(v[11]-'0');
+
+	time_data.tm_isdst = 0;
+	time_data.tm_wday = 0;
+	time_data.tm_yday = 0;
+	time_data.tm_sec = 0;
+#ifdef UTIL_CHECKED_STRFTIME
+	if (OpStatus::IsError(CheckedStrftime(sp, 100, UNI_L("%x %X GMT"), &time_data)))
+		return 0;
+#else
+	if(g_oplocale->op_strftime(sp, 100, UNI_L("%x %X GMT"), &time_data) > 100)
+		return 0;
+#endif
+	return(1);
+err:
+    uni_strcpy(sp,UNI_L("Bad time value"));
+    return(0);
+    }
diff -Naur openssl-1.0.0q.orig/core_includes.h openssl-1.0.0q/core_includes.h
--- openssl-1.0.0q.orig/core_includes.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/core_includes.h	2017-04-25 16:23:39.698527882 +0200
@@ -0,0 +1,38 @@
+/* -*- Mode: c++; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*-
+**
+** Copyright (C) 2008 Opera Software ASA.  All rights reserved.
+**
+** This file is part of the Opera web browser.  It may not be distributed
+** under any circumstances.
+**
+*/
+
+/**
+ * @file core_includes.h
+ *
+ * This file is included in all opera_*.cpp wrapper files in libopeay.
+ *
+ * This file must be included exactly once.
+ * This file must not be included from other modules.
+ *
+ */
+
+#ifdef CORE_INCLUDES_H
+#error This file must be included exactly once, from an opera_*.cpp wrapper file.
+#endif
+#define CORE_INCLUDES_H
+
+/* Add c++ header files that can not be included from the C source files here: */
+#include "modules/util/datefun.h"
+
+#define LIBOPEAY_X509_EX_DATA
+
+#ifdef MSWIN
+// avoid collisions with the debug free
+#undef free
+#endif // MSWIN
+
+// op_functions.h must be included in the resulting compilation unit just
+// before an *.c OpenSSL source file. Therefore its include statement must
+// be the last line of this file.
+#include "modules/libopeay/addon/op_functions.h"
diff -Naur openssl-1.0.0q.orig/create_wrappers.py openssl-1.0.0q/create_wrappers.py
--- openssl-1.0.0q.orig/create_wrappers.py	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/create_wrappers.py	2017-04-25 16:23:39.700527857 +0200
@@ -0,0 +1,211 @@
+#!/usr/bin/env python
+
+import os.path
+import sys
+import StringIO
+import optparse
+
+sys.path.insert(1, os.path.join(sys.path[0], '..', '..', 'modules', 'hardcore', 'scripts'))
+import module_sources
+import util
+
+class WrapperModuleSources(module_sources.ModuleSources):
+    """
+    This class extends the parser of module.sources by two new options:
+    - "cpp" (default disabled) can be used for all source-files
+      starting with "opera_" to indicate that the original source-file
+      is a cpp-file and not a c-file; so the wrapper can create the
+      correct include statement.
+    - forcecompileif=statement can be used to compile the source-code
+      if the specifed preprocessor statement is true.
+    """
+    def __init__(self):
+        module_sources.ModuleSources.__init__(self, 'modules', 'libopeay')
+
+    def cpp(self, source):
+        """
+        This option is used for all source-files starting with
+        "opera_" to indicate that the original source-file is a
+        cpp-file and not a c-file. So the wrapper can create the
+        correct include statement.
+        @param source is the source file to check.
+        @return True if the specified source-file has the
+          option cpp set and False otherwise (False is default).
+        """
+        return self.getSourceOption(source, "cpp", "0") == "1"
+
+    def forcecompileif(self, source):
+        """
+        The forcecompileif statement is used to compile the
+        source-code if the specifed preprocessor statement is true.
+
+        @param source is the source file to check.
+        @return the preprocessor statement or None if the option is
+          not set.
+        """
+        return self.getSourceOption(source, "forcecompileif", None)
+
+    def external_ssl_only(self, source):
+        """
+        The external-ssl-only statement is used to compile the
+        source-code with an "#ifdef EXTERNAL_SSL_OPENSSL_IMPLEMENTATION"
+        statement. Without this option, the source-code is compiled
+        with an "#ifdef _SSL_USE_OPENSSL_" statement.
+
+        @param source is the source file to check.
+        @return True if the specified source-file has the
+          option external-ssl-only set and False otherwise (False is
+          default).
+        """
+        return self.getSourceOption(source, "external-ssl-only", "0") == "1"
+
+    def include_with_system_lib(self, source):
+        """
+        The include-with-system-lib statement is used for source-files
+        that should be compiled even if
+        TWEAK_LIBOPEAY_USE_SYSTEM_OPENSSL_LIBRARY is enabled (i.e. an
+        external openssl library is used). Source files without this
+        option will be wrapped inside an
+        "#if !defined(_USE_SYSTEM_LIBCRYPTO_)" statement.
+
+        @param source is the source file to check.
+        @return True if the specified source-file has the
+          option include-with-system-lib set and False otherwise (False is
+          default).
+        """
+        return self.getSourceOption(source, "include-with-system-lib", "0") == "1"
+
+    def getSourceOptionString(self, source):
+        """
+        Returns the options string for the specified source file. The
+        options string can be used to update the file module.sources.
+        """
+        options = []
+        if self.nopch(source) and self.system_includes(source):
+            options.append("winnopch")
+        if self.nopch(source): options.append("no-pch")
+        if self.system_includes(source):
+            options.append("system_includes")
+        if self.cpp(source):
+            options.append("cpp")
+        if self.external_ssl_only(source):
+            options.append("external-ssl-only")
+        if self.include_with_system_lib(source):
+            options.append("include-with-system-lib")
+        forcecompileif = self.forcecompileif(source)
+        if forcecompileif:
+            options.append("forcecompileif=%s" % forcecompileif)
+        return ";".join(options)
+
+class HandleTemplateAction:
+    def __init__(self, cpp, module_sources, source_file, original_filename):
+        self.__cpp = cpp
+        self.__system_includes = module_sources.system_includes(source_file)
+        self.__forcecompileif = module_sources.forcecompileif(source_file)
+        self.__include_with_system_lib = module_sources.include_with_system_lib(source_file)
+        if module_sources.external_ssl_only(source_file):
+            self.__define = "EXTERNAL_SSL_OPENSSL_IMPLEMENTATION"
+        else:
+            self.__define = "_SSL_USE_OPENSSL_"
+        self.__original_filename = original_filename
+
+    def __call__(self, action, output):
+        if action == "header":
+            if self.__system_includes:
+                output.write("#include \"core/pch_system_includes.h\"\n")
+            else:
+                output.write("#include \"core/pch.h\"\n")
+            if not self.__cpp:
+                output.write("#include \"modules/libopeay/core_includes.h\"\n")
+            return True
+
+        elif action == "compileif start":
+            output.write("#if defined(%s)" % self.__define)
+            if self.__forcecompileif:
+                output.write(" || %s" % self.__forcecompileif)
+            output.write("\n")
+            if not self.__include_with_system_lib:
+                output.write("# if !defined(_USE_SYSTEM_LIBCRYPTO_)\n")
+            return True
+
+        elif action == "compileif end":
+            if not self.__include_with_system_lib:
+                output.write("# endif // !_USE_SYSTEM_LIBCRYPTO_\n")
+            output.write("#endif // %s" % self.__define)
+            if self.__forcecompileif:
+                output.write(" || %s" % self.__forcecompileif)
+            output.write("\n")
+            return True
+
+        elif action == "extern C start":
+            if not self.__cpp: output.write('extern "C" {\n')
+            return True
+
+        elif action == "extern C end":
+            if not self.__cpp: output.write('}\n')
+            return True
+
+        elif action == "original filename":
+            output.write('#include "modules/libopeay/%s"\n' % self.__original_filename)
+            return True
+
+option_parser = optparse.OptionParser(
+    description="(Re-)Generates the wrapper files for the openssl source files.")
+option_parser.parse_args()
+
+module_sources_out = StringIO.StringIO()
+module_sources_out.write("# [no-jumbo]\n")
+comments = ["Note: don't use jumbo-compile for libopeay, because this code",
+            "contains a lot of wrappers around external C-sources which",
+            "contain a lot of #define macros and static local functions which",
+            "generate a lot of conflicting declarations...",
+            "Note: this file is automatically generated by create_wrappers.py",
+            "source-files and options are preserved, but comments are not ..."
+            ]
+for line in comments:
+    module_sources_out.write("# %s\n" % line)
+module_sources_out.write("\n")
+
+sourceRoot = os.path.normpath(os.path.join(sys.path[0], '..', '..'))
+libopeayDir = os.path.join(sourceRoot, 'modules', 'libopeay')
+wrapper_template = os.path.join(libopeayDir, 'wrapper_template.cpp')
+module_sources = WrapperModuleSources()
+module_sources.load(os.path.join(libopeayDir, 'module.sources'))
+changed_files = []
+for source_file in module_sources.sources_all():
+    file_path = source_file.split('/')
+    filename = file_path[-1]
+    original_filename = filename
+    (sourcename, dot, extension) = filename.partition(".")
+    if sourcename.startswith("opera_"):
+        extension = "c"
+        if module_sources.cpp(source_file):
+            extension = "cpp"
+        original_filename = sourcename[6:] + "." + extension
+    else:
+        extension = "c"
+        filename = "opera_" + sourcename + ".cpp"
+    file_path[-1] = filename;
+
+    options = module_sources.getSourceOptionString(source_file)
+    if len(options) == 0:
+        module_sources_out.write("%s\n" % '/'.join(file_path))
+    else:
+        module_sources_out.write("%s # [%s]\n" % ('/'.join(file_path).ljust(34), options))
+    if util.readTemplate(wrapper_template,
+                         os.path.join(libopeayDir, *file_path),
+                         HandleTemplateAction(extension=="cpp",
+                                              module_sources,
+                                              source_file,
+                                              "/".join(file_path[0:-1] + [original_filename]))):
+        changed_files.append(os.path.join(*file_path))
+
+if util.updateFile(module_sources_out,
+                   os.path.join(libopeayDir, "module.sources")):
+    print "module.sources updated"
+else:
+    print "module.sources not changed"
+if len(changed_files):
+    print "%d wrapper files updated:" % len(changed_files), changed_files
+else:
+    print "No wrapper file changed"
diff -Naur openssl-1.0.0q.orig/crypto/.gitignore openssl-1.0.0q/crypto/.gitignore
--- openssl-1.0.0q.orig/crypto/.gitignore	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/crypto/.gitignore	2017-04-25 16:23:39.700527857 +0200
@@ -0,0 +1,2 @@
+/.depend
+/*.d
diff -Naur openssl-1.0.0q.orig/crypto/LPdir_unix.c openssl-1.0.0q/crypto/LPdir_unix.c
--- openssl-1.0.0q.orig/crypto/LPdir_unix.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/LPdir_unix.c	2017-04-25 16:23:39.702525876 +0200
@@ -25,6 +25,9 @@
  * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  */
 
+#error("/* ARRAY FILE UNUSED. CHECK ARRAYS BEFORE USING */")
+
+
 #include <stddef.h>
 #include <stdlib.h>
 #include <limits.h>
diff -Naur openssl-1.0.0q.orig/crypto/LPdir_vms.c openssl-1.0.0q/crypto/LPdir_vms.c
--- openssl-1.0.0q.orig/crypto/LPdir_vms.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/LPdir_vms.c	2017-04-25 16:23:39.703526003 +0200
@@ -24,6 +24,9 @@
  * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  */
 
+#error("/* ARRAY FILE UNUSED. CHECK ARRAYS BEFORE USING */")
+
+
 #include <stddef.h>
 #include <stdlib.h>
 #include <string.h>
diff -Naur openssl-1.0.0q.orig/crypto/LPdir_win.c openssl-1.0.0q/crypto/LPdir_win.c
--- openssl-1.0.0q.orig/crypto/LPdir_win.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/LPdir_win.c	2017-04-25 16:23:39.705526537 +0200
@@ -23,6 +23,9 @@
  * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
  * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  */
+
+#error("/* ARRAY FILE UNUSED. CHECK ARRAYS BEFORE USING */")
+
 #include <windows.h>
 #include <tchar.h>
 #ifndef LPDIR_H
diff -Naur openssl-1.0.0q.orig/crypto/aes/.gitignore openssl-1.0.0q/crypto/aes/.gitignore
--- openssl-1.0.0q.orig/crypto/aes/.gitignore	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/crypto/aes/.gitignore	2017-04-25 16:23:39.706526105 +0200
@@ -0,0 +1,2 @@
+/.depend
+/*.d
diff -Naur openssl-1.0.0q.orig/crypto/aes/aes.h openssl-1.0.0q/crypto/aes/aes.h
--- openssl-1.0.0q.orig/crypto/aes/aes.h	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/aes/aes.h	2017-04-25 16:23:39.708526360 +0200
@@ -58,7 +58,9 @@
 #error AES is disabled.
 #endif
 
+#ifndef OPERA_SMALL_VERSION
 #include <stddef.h>
+#endif // !OPERA_SMALL_VERSION
 
 #define AES_ENCRYPT	1
 #define AES_DECRYPT	0
@@ -114,8 +116,8 @@
 	unsigned char *ivec, int *num);
 void AES_ctr128_encrypt(const unsigned char *in, unsigned char *out,
 	size_t length, const AES_KEY *key,
-	unsigned char ivec[AES_BLOCK_SIZE],
-	unsigned char ecount_buf[AES_BLOCK_SIZE],
+	unsigned char ivec[AES_BLOCK_SIZE],       /* ARRAY OK UNUSED OPERA 2007-04-23 yngve*/
+	unsigned char ecount_buf[AES_BLOCK_SIZE], /* ARRAY OK UNUSED OPERA 2007-04-23 yngve*/
 	unsigned int *num);
 /* NB: the IV is _two_ blocks long */
 void AES_ige_encrypt(const unsigned char *in, unsigned char *out,
diff -Naur openssl-1.0.0q.orig/crypto/aes/aes_cbc.c openssl-1.0.0q/crypto/aes/aes_cbc.c
--- openssl-1.0.0q.orig/crypto/aes/aes_cbc.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/aes/aes_cbc.c	2017-04-25 16:23:39.710528849 +0200
@@ -49,6 +49,8 @@
  *
  */
 
+#ifndef OPENSSL_NO_AES
+
 #include <openssl/aes.h>
 #include <openssl/modes.h>
 
@@ -61,3 +63,5 @@
 	else
 		CRYPTO_cbc128_decrypt(in,out,len,key,ivec,(block128_f)AES_decrypt);
 }
+
+#endif
diff -Naur openssl-1.0.0q.orig/crypto/aes/aes_cfb.c openssl-1.0.0q/crypto/aes/aes_cfb.c
--- openssl-1.0.0q.orig/crypto/aes/aes_cfb.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/aes/aes_cfb.c	2017-04-25 16:23:39.712527986 +0200
@@ -49,6 +49,8 @@
  *
  */
 
+#if !defined OPENSSL_NO_AES && defined OPENSSL_USE_CFB_CIPHERS
+
 #include <openssl/aes.h>
 #include <openssl/modes.h>
 
@@ -79,3 +81,4 @@
     CRYPTO_cfb128_8_encrypt(in,out,length,key,ivec,num,enc,(block128_f)AES_encrypt);
     }
 
+#endif
diff -Naur openssl-1.0.0q.orig/crypto/aes/aes_core.c openssl-1.0.0q/crypto/aes/aes_core.c
--- openssl-1.0.0q.orig/crypto/aes/aes_core.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/aes/aes_core.c	2017-04-25 16:23:39.715528646 +0200
@@ -28,14 +28,20 @@
 /* Note: rewritten a little bit to provide error control and an OpenSSL-
    compatible API */
 
+#ifndef OPENSSL_NO_AES
+
 #ifndef AES_DEBUG
 # ifndef NDEBUG
 #  define NDEBUG
 # endif
 #endif
+
+#ifndef OPERA_SMALL_VERSION
 #include <assert.h>
 
 #include <stdlib.h>
+#endif
+
 #include <openssl/aes.h>
 #include "aes_locl.h"
 
@@ -1356,3 +1362,5 @@
 }
 
 #endif /* AES_ASM */
+
+#endif
diff -Naur openssl-1.0.0q.orig/crypto/aes/aes_ecb.c openssl-1.0.0q/crypto/aes/aes_ecb.c
--- openssl-1.0.0q.orig/crypto/aes/aes_ecb.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/aes/aes_ecb.c	2017-04-25 16:23:39.717528621 +0200
@@ -54,7 +54,9 @@
 #  define NDEBUG
 # endif
 #endif
+#ifndef OPERA_SMALL_VERSION
 #include <assert.h>
+#endif /* !OPERA_SMALL_VERSION */
 
 #include <openssl/aes.h>
 #include "aes_locl.h"
diff -Naur openssl-1.0.0q.orig/crypto/aes/aes_locl.h openssl-1.0.0q/crypto/aes/aes_locl.h
--- openssl-1.0.0q.orig/crypto/aes/aes_locl.h	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/aes/aes_locl.h	2017-04-25 16:23:39.718526793 +0200
@@ -58,9 +58,11 @@
 #error AES is disabled.
 #endif
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
+#endif /* !OPERA_SMALL_VERSION */
 
 #if defined(_MSC_VER) && (defined(_M_IX86) || defined(_M_AMD64) || defined(_M_X64))
 # define SWAP(x) (_lrotl(x, 8) & 0x00ff00ff | _lrotr(x, 8) & 0xff00ff00)
diff -Naur openssl-1.0.0q.orig/crypto/asn1/.gitignore openssl-1.0.0q/crypto/asn1/.gitignore
--- openssl-1.0.0q.orig/crypto/asn1/.gitignore	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/.gitignore	2017-04-25 16:23:39.723526311 +0200
@@ -0,0 +1,2 @@
+/.depend
+/*.d
diff -Naur openssl-1.0.0q.orig/crypto/asn1/a_bitstr.c openssl-1.0.0q/crypto/asn1/a_bitstr.c
--- openssl-1.0.0q.orig/crypto/asn1/a_bitstr.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/a_bitstr.c	2017-04-25 16:23:39.724525879 +0200
@@ -56,12 +56,16 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/asn1.h>
 
+#ifdef LIBOPEAY_ASYNCHRONOUS_KEYGENERATION
 int ASN1_BIT_STRING_set(ASN1_BIT_STRING *x, unsigned char *d, int len)
 { return M_ASN1_BIT_STRING_set(x, d, len); }
+#endif
 
 int i2c_ASN1_BIT_STRING(ASN1_BIT_STRING *a, unsigned char **pp)
 	{
@@ -106,7 +110,7 @@
 
 	*(p++)=(unsigned char)bits;
 	d=a->data;
-	memcpy(p,d,len);
+	op_memcpy(p,d,len);
 	p+=len;
 	if (len > 0) p[-1]&=(0xff<<bits);
 	*pp=p;
@@ -155,7 +159,7 @@
 			i=ERR_R_MALLOC_FAILURE;
 			goto err;
 			}
-		memcpy(s,p,(int)len);
+		op_memcpy(s,p,(int)len);
 		s[len-1]&=(0xff<<i);
 		p+=len;
 		}
@@ -207,7 +211,7 @@
 			ASN1err(ASN1_F_ASN1_BIT_STRING_SET_BIT,ERR_R_MALLOC_FAILURE);
 			return 0;
 			}
-  		if (w+1-a->length > 0) memset(c+a->length, 0, w+1-a->length);
+		if (w+1-a->length > 0) op_memset(c+a->length, 0, w+1-a->length);
 		a->data=c;
 		a->length=w+1;
 	}
diff -Naur openssl-1.0.0q.orig/crypto/asn1/a_bool.c openssl-1.0.0q/crypto/asn1/a_bool.c
--- openssl-1.0.0q.orig/crypto/asn1/a_bool.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/a_bool.c	2017-04-25 16:23:39.726525854 +0200
@@ -56,10 +56,13 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/asn1t.h>
 
+#ifndef OPERA_SMALL_VERSION
 int i2d_ASN1_BOOLEAN(int a, unsigned char **pp)
 	{
 	int r;
@@ -110,5 +113,6 @@
 	ASN1err(ASN1_F_D2I_ASN1_BOOLEAN,i);
 	return(ret);
 	}
+#endif
 
 
diff -Naur openssl-1.0.0q.orig/crypto/asn1/a_bytes.c openssl-1.0.0q/crypto/asn1/a_bytes.c
--- openssl-1.0.0q.orig/crypto/asn1/a_bytes.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/a_bytes.c	2017-04-25 16:23:39.728528064 +0200
@@ -56,10 +56,13 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/asn1.h>
 
+#if !defined(OPERA_SMALL_VERSION) || defined(EXTERNAL_SSL_OPENSSL_IMPLEMENTATION)
 static int asn1_collate_primitive(ASN1_STRING *a, ASN1_const_CTX *c);
 /* type is a 'bitmap' of acceptable string types.
  */
@@ -107,7 +110,7 @@
 			i=ERR_R_MALLOC_FAILURE;
 			goto err;
 			}
-		memcpy(s,p,(int)len);
+		op_memcpy(s,p,(int)len);
 		s[len]='\0';
 		p+=len;
 		}
@@ -148,7 +151,7 @@
 	else
 		constructed=0;
 	ASN1_put_object(&p,constructed,ret,tag,xclass);
-	memcpy(p,a->data,a->length);
+	op_memcpy(p,a->data,a->length);
 	p+=a->length;
 	*pp= p;
 	return(r);
@@ -219,7 +222,7 @@
 				}
 			else
 				s=ret->data;
-			memcpy(s,p,(int)len);
+			op_memcpy(s,p,(int)len);
 			s[len] = '\0';
 			p+=len;
 			}
@@ -243,8 +246,9 @@
 	ASN1err(ASN1_F_D2I_ASN1_BYTES,i);
 	return(NULL);
 	}
+#endif
 
-
+#if !defined(OPERA_SMALL_VERSION) || defined(EXTERNAL_SSL_OPENSSL_IMPLEMENTATION)
 /* We are about to parse 0..n d2i_ASN1_bytes objects, we are to collapse
  * them into the one structure that is then returned */
 /* There have been a few bug fixes for this function from
@@ -292,7 +296,7 @@
 			c->error=ERR_R_BUF_LIB;
 			goto err;
 			}
-		memcpy(&(b.data[num]),os->data,os->length);
+		op_memcpy(&(b.data[num]),os->data,os->length);
 		if (!(c->inf & 1))
 			c->slen-=(c->p-c->q);
 		num+=os->length;
@@ -312,3 +316,4 @@
 	return(0);
 	}
 
+#endif
